#include <iostream>
#include <bits/stdc++.h>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);
    
    int en, ka;
    
    cin >> en >> ka;
    
    int nizbre[en];
    
    for (int rokaj = 0; rokaj < en; rokaj++){
        cin >> nizbre[rokaj];
    }
    
    int ej[en*2+1];
    
    for(int eveme = 0; eveme < en*2+1; eveme++){
        ej[eveme] = 0;
    }
    
    for (int rokaj = 0; rokaj < en; rokaj++){
        int alo = nizbre[rokaj];
        if(alo < 0){
            alo = -1 * alo + en;
        }
        ej[alo]++;
    }
    int counterbre = 0;
    int skorz[en*2+1];
    
    for(int eveme = 0; eveme < en*2+1; eveme++){
        if(ej[eveme]>=ka){
            int alo2 = eveme;
            if (alo2 > en){
                alo2 = -1*(alo2 - en);
            }
            skorz[counterbre] = alo2;
            counterbre++;
        }
    }
    
    cout << counterbre << endl;
    
    for(int fajnl = 0; fajnl < counterbre; fajnl++){
        cout << skorz[fajnl] << " ";
    }
    
    return 0;
}